/*
 * User Management JavaScript Library
 * Copyright (c) 2015 mxchip.com
 * 所有项目都可以使用，注意是leancloud的相关接口
 */
(function(window) {
    AV.$ = jQuery;
    var _APPID = 'UQMdVaLUWTdFijs9A3eojYkv-gzGzoHsz';
    var _APPKEY = 'D5CbIjCXpxCYfcjuY2UtGkjl';
    var _MASTERKEY = 'JjkVfUlCRuMK0jmBWtl5tJCb';

    //用config.js中的appId，appKey初始化，若你搭建自己的js，请用你的appId与appKey
    // AV.initialize(_APPID, _APPKEY);
    AV.init({
      appId: _APPID,
      appKey: _APPKEY
    });
    var m = {};

    function sucRet() {
        var b = '{"code":"' + errcode("") + '","msg":"没找到"}';
        var bToObj = JSON.parse(b);
        return bToObj;
    }

    function errcode(sit) {
        switch (sit) {
            case "":
                return 1;
        }
    }

    function errRet(code, msg) {
        var b = '{"code":"' + errcode("") + '","msg":"' + msg + '"}';
        var bToObj = JSON.parse(b);
        return bToObj;
    }

    //获取登录信息
    // m.islogin = function() {
    //     var currentUser = AV.User.current();
    //     return currentUser;
    // };

    //注册用户
    m.loginWithPhone = function(phone, psw, callback) {
        var sucm;
        var errm;
        AV.User.logInWithMobilePhone(phone, psw).then(function(user) {
            //登录成功
            callback(user, errm);
        }, function(err) {
            //登录失败
            callback(sucm, err);
        });
    };

    // //请求重新验证手机号
    // m.requestMobilePhoneVerify = function(phone, callback) {
    //     var errm;        
    //     AV.User.requestMobilePhoneVerify(phone).then(function(){
    //         //验证成功
    //         callback(true, errm);
    //     }, function(err){
    //         //验证失败
    //         callback(false, err);
    //     });
    // };
    //验证验证码但是不登录
    m.verifySmsCode = function(vercode, phone, callback) {
        var errm;
        AV.Cloud.verifySmsCode(vercode, phone).then(function() {
            //验证成功
            callback(true, errm);
        }, function(err) {
            //验证失败
            callback(false, err);
        });
    };

    //注册或者找回密码时候获取验证码
    m.getSmsCode = function(phone, callback) {
        // alert(phone + "---");
        AV.Cloud.requestSmsCode(phone).then(function() {
            //发送成功
            callback("0");
        }, function(err) {
            //发送失败
            callback(err);
        });
    };
    //注册或者找回密码时候获取验证码
    m.getVoiceSmsCode = function(phone, smsType, callback) {
        // alert(phone + "---");
        // {"mobilePhoneNumber": "186xxxxxxxx", "smsType":"voice"}
        // voice：发送语音验证码
        // sms：发送普通短信验证码
        AV.Cloud.requestSmsCode({"mobilePhoneNumber": phone, "smsType":smsType}).then(function() {
            //发送成功
            callback("0");
        }, function(err) {
            //发送失败
            callback(err);
        });
    };

    //验证获取的验证码并登录
    m.signUpOrlogInByPhone = function(phone, identify, callback) {
        var user = new AV.User();
        var sucm;
        var errm;
        user.signUpOrlogInWithMobilePhone({
            mobilePhoneNumber: phone,
            smsCode: identify,
        }, {
            success: function(user) {
                //注册或者登录成功
                callback(user, errm);
            },
            error: function(err) {
                //失败
                callback(sucm, err);
            }
        });
    };

    //设置初始密码
    m.setPassword = function(password, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.setPassword(password);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    };

    //去EasyCloud注册
    m.regToEasyCloud = function(phone, password, callback) {
        var sucm;
        var errm;
        AV.Cloud.run('registerToEasyCloud', {
            login_id: phone,
            password: password
        }, {
            success: function(data) {
                //调用成功，得到成功的应答data
                //在EasyCloud注册成功后还需要将token写到LeanCloud的用户列表里
                var usertoken = data.data.token;
                var user = AV.User.current();
                user.set('userToken', usertoken);
                user.save().then(function(user) {
                    //验证成功
                    callback(data, errm);
                }, function(errsave) {
                    //验证失败
                    callback(sucm, errsave);
                });
            },
            error: function(err) {
                //处理调用失败
                callback(sucm, err);
            }
        });
    };

    //修改当前用户密码
    m.updatePassword = function(oldpsw, password, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.updatePassword(oldpsw, password, {
            success: function(ret) {
                //更新成功
                callback(ret, errm);
            },
            error: function(err) {
                //更新失败
                callback(sucm, err);
            }
        });
    };

    //修改当前用户昵称
    m.updateNickName = function(nickname, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.set('nickname', nickname);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    };    

    //修改当前用户昵称
    m.updateUserName = function(username, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.set('username', username);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    };

    //修改手机号
    m.updatePhone = function(phone, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.set('mobilePhoneNumber', phone);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    };

    //修改当前用户邮箱
    m.updateEmail = function(email, callback) {
        var sucm;
        var errm;
        var user = AV.User.current();
        user.set('email', email);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    };

    //保存支付宝帐号
    m.savealipay = function(truename, alipayaccount, callback) {
        // var TodoFolder = AV.Object.extend('TodoFolder'); // 声明类型
        // var todoFolder = new TodoFolder(); // 新建对象
        // todoFolder.set('name', '工作'); // 设置名称
        // todoFolder.set('priority', 1); // 设置优先级
        // todoFolder.save().then(function(todo) {
        // }, function(error) {
        // }); // 保存到云端

        var sucm;
        var errm;

        var user = AV.User.current();
        user.set('truename', truename);
        user.set('alipayaccount', alipayaccount);
        user.save().then(function(user) {
            //验证成功
            callback(user, errm);
        }, function(err) {
            //验证失败
            callback(sucm, err);
        });
    }

    //发送反馈信息
    m.sendFeedback = function(username, qqnumber, content, callback) {
        var sucm;
        var errm;
        //      alert(APP_NAME+" "+phone+" "+content);
        //AV.Object
        var fd = AV.Object.new('feedback');
        fd.set("username", username);
        fd.set("qqnumber", qqnumber);
        fd.set("fdcontent", content);
        fd.save().then(function(ret) {
                // Execute any logic that should take place after the object is saved.
                //              alert('New object created with objectId: ' + fd.id);
                //fd成功
                callback(ret, errm);
        }, function(err) {
                // Execute any logic that should take place if the save fails.
                // error is a AV.Error with an error code and description.
                //              alert('Failed to create new object, with error code: ' + err.message);
                //fd失败
                callback(sucm, err);
        });
    };

    //交易完成保存交易记录
    m.savemyorder = function(userid, title, price, openiid, rate, picurl, tblog, callback) {
        var sucm;
        var errm;
        var fd = AV.Object.new('myorder');
        fd.set("userid", userid);
        fd.set("title", title);
        fd.set("promotion_price", price);
        fd.set("openiid", openiid);
        fd.set("commission_rate", parseFloat(rate));
        fd.set("pic_url", picurl);
        fd.set("tblog", tblog);
        fd.save().then(function(ret) {
            callback(ret, errm);
        }, function(err) {
            callback(sucm, err);
        });
    };

    //保存搜索的关键字
    m.savekeyword = function(userid, keyword, callback) {
        var sucm;
        var errm;
        var fd = AV.Object.new('keyword_user');
        fd.set("userid", userid);
        fd.set("keyword", keyword);
        fd.save().then(function(ret) {
            callback(ret, errm);
        }, function(err) {
            callback(sucm, err);
        });
    };

    //收藏宝贝
    m.savetofavorite = function(topicid, userid, callback) {
        var sucm;
        var errm;
        var fd = AV.Object.new('favorites');
        fd.set("topicid", topicid);
        fd.set("userid", userid);
        fd.save().then(function(ret) {
            callback(ret, errm);
        }, function(err) {
            callback(sucm, err);
        });
    };

    //取消收藏
    m.rmfavorite = function(favoriteid, callback) {
        var sucm;
        var errm;
        var fd = AV.Object.createWithoutData('favorites', favoriteid);
        fd.destroy().then(function(ret) {
            callback(ret, errm);
        }, function(err) {
            callback(sucm, err);
        });
    };

    //保存订单的问题
    m.sendmoneyqa = function(userid, taobaoorderid, question, qqnumber, callback) {
        var sucm;
        var errm;
        var fd = AV.Object.new('money_qa');
        fd.set("userid", userid);
        fd.set("taobaoorderid", taobaoorderid);
        fd.set("question", question);
        fd.set("qqnumber", qqnumber);
        fd.save().then(function(ret) {
            callback(ret, errm);
        }, function(err) {
            callback(sucm, err);
        });
    };

    //判断用户是否存在
    m.isExist = function(username, callback) {
        var sucm;
        var errm;
        var query = new AV.Query(AV.User);
        query.equalTo("username", username);
        query.find({
            success: function(ret) {
                callback(ret, errm);
            },
            error: function(err) {
                callback(sucm, err);
            }
        });
    };

    //判断是否登录
    m.isLogin = function() {
        //  alert("in");
        var currentUser = AV.User.current();
        //  alert(currentUser);
        if (currentUser) {
            return true;
        } else {
            return false;
        }
    };

    /*end*/
    // api.buyhezi.cn, 获取淘宝返利信息
    const _TAOBAO_APPKEY = '23255704';
    const _TAOBAO_APPSECRET = 'e53187dca57c82a02fc48ca79c57263d';
    m.taobaogetitems = function(keyword, pagesize, pageno, sort, callback) {
        var sucm;
        var errm;
        var param = {
            "appkey": _TAOBAO_APPKEY,
            "appsecret": _TAOBAO_APPSECRET,
            "fields": 'open_iid,title,pic_url,nick,item_location,commission_rate,promotion_price',
            "apiname": 'taobao.atb.items.get',
            "keyword": keyword,
            "sort": sort,
            "page_size": pagesize,
            "page_no": pageno,
        };
        $.ajax({
            url: "http://api.buyhezi.cn/getitems",
            type: 'POST',
            data: param,
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
            },
            success: function(ret) {
                callback(ret, errm);
            },
            error: function(err) {
                callback(sucm, err);
            }
        });
    };

    m.getQueryString = function(name) {
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i');
        var r = window.location.search.substr(1).match(reg);
        if (r != null) {
            return unescape(r[2]);
        }
        return null;
    };

    window.FEEL = m;

})(window);
